# Created on 09/12/2021
from polynome import *
from itertools import combinations

def get_possibilities(l: list):

	# Transforme the list in list of tupples with their indexes
	for x, _ in enumerate(l):
		l[x] = (x, l[x])

	# ! la valeur 20 est hardcodée. Paramètre de fonction ??

	l_fixe = l[20:] # Liste contenant aucune erreur
	l_posi = l[:20] # Liste contenant des erreurs, 

	p = list(combinations(l_posi, 2))

	for x, y in enumerate(p):
		p[x] = list(y)
		p[x].extend(l_fixe)

	return p

# l : List of tuple (x, y)
def lagrange_compute(l: list) -> polynome:
	# Produit de k = 0 > n
	# bébé lagrange pour premier tuple choisit
	from inverse_mult import inverse_mult

	x = l[0][0]
	coefs = []
	for i, t in enumerate(l):
		if(x != l[i][0]):
			print(f"")
			print(f"{t[0] * x} / inverse({x - t[0]} - 229)")
			coefs.append(t[0] * inverse_mult(x - t[0], 229))
	print(f"DEBUG {coefs}")
	return polynome(coefs)

def check_nb_error(l: list, p: polynome) -> int:
	
	nbr_error = 0
	for _, item in enumerate(l):
		if (item % p.prime_mod) != (p.evaluate(_) % p.prime_mod):
			print(f"DEBUG PURPOSES ONLY {item} != p.evaluate({_}) = {p.evaluate(_)}")
			nbr_error += 1
	return nbr_error